<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: NormalForms.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>NormalForms.c File Reference</h1><code>#include &lt;stdlib.h&gt;</code><br/>
<code>#include &lt;<a class="el" href="polylib_8h_source.html">polylib/polylib.h</a>&gt;</code><br/>

<p><a href="NormalForms_8c_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#a0700cce3ebc6105adf3f1f6923102c1f">moins_l</a> (Value *a, int i, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#a4b7573e49ac163edebd1173245ccecdc">moins_c</a> (Value *a, int i, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#ae4f3c7e196dd764e7af535daaa55a6ea">echange_l</a> (Value *a, int i, int j, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#acd8406952e74e5e1582a57d4f1fd4bf0">echange_c</a> (Value *a, int i, int j, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#aa93c4b505b57bb49c850a849abcf03f1">ligne</a> (Value *a, int i, int j, Value x, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#a32c21d377e6f4e0d40c49194431d65e9">colonne</a> (Value *a, int i, int j, Value x, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#af13227d454a50973add06d8d5b959c7b">petit_l</a> (Value *a, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, int q)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#af20cf6fb619a43ae81d56430c72e2113">petit_c</a> (Value *a, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, int q)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#a14df81f2b3dd956f72286a02b66457ab">identite</a> (Value *a, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#aa89e5160f2aae2765d3255b844946673">transpose</a> (Value *a, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int q)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#a305ba3846eeba4506a1dd5357aa4d645">encore</a> (Value *a, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, int q, Value val)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#a4524ad33f7159f7e0048a9c20735f9d8">smith</a> (Value *a, Value *b, Value *c, Value *b_inverse, Value *c_inverse, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, int q)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#a618ae7edc1483b88e4ebd07843fb26bf">hermite</a> (Value *a, Value *b, Value *d, int <a class="el" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>, int <a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, int q)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static Value *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#afea663b3d4157f7d798bac5bef2f37af">ConvertPolMattoDarMat</a> (<a class="el" href="structmatrix.html">Matrix</a> *A)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert PolmattoDarmat : This function converts the <a class="el" href="structmatrix.html">matrix</a> of a Polylib to a int * as necessary for the functions in Darte's implementation.  <a href="#afea663b3d4157f7d798bac5bef2f37af"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#a29b2e49afa0c05a71ad44c5715d96aa2">ConvertDarMattoPolMat</a> (Value *A, int NbRows, int NbCols)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert DarmattoPolmat This function converts the <a class="el" href="structmatrix.html">matrix</a> from Darte representation to a <a class="el" href="structmatrix.html">matrix</a> in PolyLib.  <a href="#a29b2e49afa0c05a71ad44c5715d96aa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#a1d5c5fdbd71ebc1eb2ce3f11ce9fbd5f">Smith</a> (<a class="el" href="structmatrix.html">Matrix</a> *A, <a class="el" href="structmatrix.html">Matrix</a> **U, <a class="el" href="structmatrix.html">Matrix</a> **V, <a class="el" href="structmatrix.html">Matrix</a> **Product)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Smith : This function takes a Matrix A of dim n * l as its input and returns the three matrices U, V and Product such that A = U * Product * V, where U is an unimodular <a class="el" href="structmatrix.html">matrix</a> of dimension n * n and V is an unimodular <a class="el" href="structmatrix.html">matrix</a> of dimension l * l.  <a href="#a1d5c5fdbd71ebc1eb2ce3f11ce9fbd5f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="NormalForms_8c.html#acd4e00bd353920b83e3f27a76909b2ed">Hermite</a> (<a class="el" href="structmatrix.html">Matrix</a> *A, <a class="el" href="structmatrix.html">Matrix</a> **H, <a class="el" href="structmatrix.html">Matrix</a> **U)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Hermite : This function takes a Matrix as its input and finds its HNF ( Left form ).  <a href="#acd4e00bd353920b83e3f27a76909b2ed"></a><br/></td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a32c21d377e6f4e0d40c49194431d65e9"></a><!-- doxytag: member="NormalForms.c::colonne" ref="a32c21d377e6f4e0d40c49194431d65e9" args="(Value *a, int i, int j, Value x, int n, int p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void colonne </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>j</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value&nbsp;</td>
          <td class="paramname"> <em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00146">146</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00516">value_addmul</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00492">hermite()</a>, and <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

</div>
</div>
<a class="anchor" id="a29b2e49afa0c05a71ad44c5715d96aa2"></a><!-- doxytag: member="NormalForms.c::ConvertDarMattoPolMat" ref="a29b2e49afa0c05a71ad44c5715d96aa2" args="(Value *A, int NbRows, int NbCols)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="structmatrix.html">Matrix</a>* ConvertDarMattoPolMat </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>A</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>NbRows</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>NbCols</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert DarmattoPolmat This function converts the <a class="el" href="structmatrix.html">matrix</a> from Darte representation to a <a class="el" href="structmatrix.html">matrix</a> in PolyLib. </p>
<p>Input : The <a class="el" href="structmatrix.html">matrix</a> (a pointer to it), number of Rows, number of columns Output : The <a class="el" href="structmatrix.html">matrix</a> of the PolyLib </p>

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00604">604</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00670">Hermite()</a>.</p>

</div>
</div>
<a class="anchor" id="afea663b3d4157f7d798bac5bef2f37af"></a><!-- doxytag: member="NormalForms.c::ConvertPolMattoDarMat" ref="afea663b3d4157f7d798bac5bef2f37af" args="(Matrix *A)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static Value* ConvertPolMattoDarMat </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>A</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert PolmattoDarmat : This function converts the <a class="el" href="structmatrix.html">matrix</a> of a Polylib to a int * as necessary for the functions in Darte's implementation. </p>
<p>Input : A Polylib Matrix ( a pointer to it ); Output : An int * with the <a class="el" href="structmatrix.html">matrix</a> copied into it </p>

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00580">580</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00670">Hermite()</a>.</p>

</div>
</div>
<a class="anchor" id="acd8406952e74e5e1582a57d4f1fd4bf0"></a><!-- doxytag: member="NormalForms.c::echange_c" ref="acd8406952e74e5e1582a57d4f1fd4bf0" args="(Value *a, int i, int j, int n, int p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void echange_c </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>j</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00093">93</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="polytest_8c_source.html#l00024">s</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00492">hermite()</a>, and <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

</div>
</div>
<a class="anchor" id="ae4f3c7e196dd764e7af535daaa55a6ea"></a><!-- doxytag: member="NormalForms.c::echange_l" ref="ae4f3c7e196dd764e7af535daaa55a6ea" args="(Value *a, int i, int j, int n, int p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void echange_l </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>j</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00067">67</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="polytest_8c_source.html#l00024">s</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00492">hermite()</a>, and <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

</div>
</div>
<a class="anchor" id="a305ba3846eeba4506a1dd5357aa4d645"></a><!-- doxytag: member="NormalForms.c::encore" ref="a305ba3846eeba4506a1dd5357aa4d645" args="(Value *a, int n, int p, int q, Value val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static int encore </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>q</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00329">329</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00529">value_absolute</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00525">value_modulus</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00553">value_zero_p</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

</div>
</div>
<a class="anchor" id="acd4e00bd353920b83e3f27a76909b2ed"></a><!-- doxytag: member="NormalForms.c::Hermite" ref="acd4e00bd353920b83e3f27a76909b2ed" args="(Matrix *A, Matrix **H, Matrix **U)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Hermite </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>A</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>H</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>U</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Hermite : This function takes a Matrix as its input and finds its HNF ( Left form ). </p>
<p>Input : A Matrix A (The Matrix A is not necessarily a Polylib <a class="el" href="structmatrix.html">matrix</a>. It is just a <a class="el" href="structmatrix.html">matrix</a> as far as Hermite is concerned. It does not even check if the <a class="el" href="structmatrix.html">matrix</a> is a Polylib <a class="el" href="structmatrix.html">matrix</a> or not) Output : The Hnf <a class="el" href="structmatrix.html">matrix</a> H and the Unimodular <a class="el" href="structmatrix.html">matrix</a> U such that A = H * U.</p>
<p>We use Alan Darte's implementation of Hermite to compute the HNF. Alan Darte's implementation computes the Upper Triangular HNF. So We work on the fact that if A = H * U then A (transpose) = U(transpose) * H (transpose) There are a set of interface functions written in Interface.c which convert a <a class="el" href="structmatrix.html">matrix</a> from Polylib representationt to that of Alan Darte's and vice versa.</p>
<p>This Function Does the Following Step 1 : Given the <a class="el" href="structmatrix.html">matrix</a> A it finds its Transpose. Step 2 : Finds the HNF (Right Form) using Alan Darte's Algorithm. Step 3 : The H1 and U1 obtained in Step2 are both Transposed to get the actual H and U such that A = HU. </p>

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00670">670</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="NormalForms_8c_source.html#l00604">ConvertDarMattoPolMat()</a>, <a class="el" href="NormalForms_8c_source.html#l00580">ConvertPolMattoDarMat()</a>, <a class="el" href="NormalForms_8c_source.html#l00492">hermite()</a>, <a class="el" href="NormalForms_8c_source.html#l00272">identite()</a>, <a class="el" href="Matop_8c_source.html#l00118">Matrix_Copy()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="Matop_8c_source.html#l00103">Transpose()</a>, <a class="el" href="NormalForms_8c_source.html#l00297">transpose()</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00176">AffineHermite()</a>, <a class="el" href="Matop_8c_source.html#l00361">findHermiteBasis()</a>, <a class="el" href="Lattice_8c_source.html#l01267">isfulldim()</a>, <a class="el" href="SolveDio_8c_source.html#l00248">RearrangeMatforSolveDio()</a>, and <a class="el" href="SolveDio_8c_source.html#l00081">SolveDiophantine()</a>.</p>

</div>
</div>
<a class="anchor" id="a618ae7edc1483b88e4ebd07843fb26bf"></a><!-- doxytag: member="NormalForms.c::hermite" ref="a618ae7edc1483b88e4ebd07843fb26bf" args="(Value *a, Value *b, Value *d, int n, int p, int q)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void hermite </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>q</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00492">492</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="NormalForms_8c_source.html#l00146">colonne()</a>, <a class="el" href="NormalForms_8c_source.html#l00093">echange_c()</a>, <a class="el" href="NormalForms_8c_source.html#l00067">echange_l()</a>, <a class="el" href="NormalForms_8c_source.html#l00121">ligne()</a>, <a class="el" href="NormalForms_8c_source.html#l00048">moins_c()</a>, <a class="el" href="NormalForms_8c_source.html#l00029">moins_l()</a>, <a class="el" href="NormalForms_8c_source.html#l00225">petit_c()</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00522">value_decrement</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00523">value_division</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00525">value_modulus</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00550">value_neg_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00528">value_oppose</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00670">Hermite()</a>.</p>

</div>
</div>
<a class="anchor" id="a14df81f2b3dd956f72286a02b66457ab"></a><!-- doxytag: member="NormalForms.c::identite" ref="a14df81f2b3dd956f72286a02b66457ab" args="(Value *a, int n, int p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void identite </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00272">272</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00670">Hermite()</a>.</p>

</div>
</div>
<a class="anchor" id="aa93c4b505b57bb49c850a849abcf03f1"></a><!-- doxytag: member="NormalForms.c::ligne" ref="aa93c4b505b57bb49c850a849abcf03f1" args="(Value *a, int i, int j, Value x, int n, int p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void ligne </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>j</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value&nbsp;</td>
          <td class="paramname"> <em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00121">121</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00516">value_addmul</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00492">hermite()</a>, and <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

</div>
</div>
<a class="anchor" id="a4b7573e49ac163edebd1173245ccecdc"></a><!-- doxytag: member="NormalForms.c::moins_c" ref="a4b7573e49ac163edebd1173245ccecdc" args="(Value *a, int i, int n, int p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void moins_c </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00048">48</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00528">value_oppose</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00492">hermite()</a>, and <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

</div>
</div>
<a class="anchor" id="a0700cce3ebc6105adf3f1f6923102c1f"></a><!-- doxytag: member="NormalForms.c::moins_l" ref="a0700cce3ebc6105adf3f1f6923102c1f" args="(Value *a, int i, int n, int p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void moins_l </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00029">29</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00528">value_oppose</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00492">hermite()</a>, and <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

</div>
</div>
<a class="anchor" id="af20cf6fb619a43ae81d56430c72e2113"></a><!-- doxytag: member="NormalForms.c::petit_c" ref="af20cf6fb619a43ae81d56430c72e2113" args="(Value *a, int n, int p, int q)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static int petit_c </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>q</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00225">225</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00529">value_absolute</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00480">value_ge</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00492">hermite()</a>, and <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

</div>
</div>
<a class="anchor" id="af13227d454a50973add06d8d5b959c7b"></a><!-- doxytag: member="NormalForms.c::petit_l" ref="af13227d454a50973add06d8d5b959c7b" args="(Value *a, int n, int p, int q)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static int petit_l </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>q</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00173">173</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00529">value_absolute</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00480">value_ge</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

</div>
</div>
<a class="anchor" id="a1d5c5fdbd71ebc1eb2ce3f11ce9fbd5f"></a><!-- doxytag: member="NormalForms.c::Smith" ref="a1d5c5fdbd71ebc1eb2ce3f11ce9fbd5f" args="(Matrix *A, Matrix **U, Matrix **V, Matrix **Product)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Smith </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>A</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>U</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>V</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>Product</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Smith : This function takes a Matrix A of dim n * l as its input and returns the three matrices U, V and Product such that A = U * Product * V, where U is an unimodular <a class="el" href="structmatrix.html">matrix</a> of dimension n * n and V is an unimodular <a class="el" href="structmatrix.html">matrix</a> of dimension l * l. </p>
<p>Product is a diagonal <a class="el" href="structmatrix.html">matrix</a> of dimension n * l.</p>
<p>We use Alan Darte's implementation of Smith for computing the Smith Normal Form </p>

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00627">627</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="Matop_8c_source.html#l00058">Identity()</a>, <a class="el" href="Matop_8c_source.html#l00118">Matrix_Copy()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00094">matrix::p_Init</a>, and <a class="el" href="NormalForms_8c_source.html#l00383">smith()</a>.</p>

<p>Referenced by <a class="el" href="Lattice_8c_source.html#l00221">AffineSmith()</a>, and <a class="el" href="Lattice_8c_source.html#l00674">Lattice2LatticeUnion()</a>.</p>

</div>
</div>
<a class="anchor" id="a4524ad33f7159f7e0048a9c20735f9d8"></a><!-- doxytag: member="NormalForms.c::smith" ref="a4524ad33f7159f7e0048a9c20735f9d8" args="(Value *a, Value *b, Value *c, Value *b_inverse, Value *c_inverse, int n, int p, int q)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void smith </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>c</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>b_inverse</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>c_inverse</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>q</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00383">383</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="NormalForms_8c_source.html#l00146">colonne()</a>, <a class="el" href="NormalForms_8c_source.html#l00093">echange_c()</a>, <a class="el" href="NormalForms_8c_source.html#l00067">echange_l()</a>, <a class="el" href="NormalForms_8c_source.html#l00329">encore()</a>, <a class="el" href="NormalForms_8c_source.html#l00121">ligne()</a>, <a class="el" href="NormalForms_8c_source.html#l00048">moins_c()</a>, <a class="el" href="NormalForms_8c_source.html#l00029">moins_l()</a>, <a class="el" href="NormalForms_8c_source.html#l00225">petit_c()</a>, <a class="el" href="NormalForms_8c_source.html#l00173">petit_l()</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00522">value_decrement</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00523">value_division</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00525">value_modulus</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00550">value_neg_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00528">value_oppose</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00627">Smith()</a>.</p>

</div>
</div>
<a class="anchor" id="aa89e5160f2aae2765d3255b844946673"></a><!-- doxytag: member="NormalForms.c::transpose" ref="aa89e5160f2aae2765d3255b844946673" args="(Value *a, int n, int q)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void transpose </td>
          <td>(</td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>q</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="NormalForms_8c_source.html#l00297">297</a> of file <a class="el" href="NormalForms_8c_source.html">NormalForms.c</a>.</p>

<p>References <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>.</p>

<p>Referenced by <a class="el" href="NormalForms_8c_source.html#l00670">Hermite()</a>, and <a class="el" href="Matop_8c_source.html#l00103">Transpose()</a>.</p>

</div>
</div>
</div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:27 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
